#include <RH_ASK.h>

class Receiver{
	void (*_messageCallback)(char *);
	unsigned int _bufferSize;
	RH_ASK _driver;

public:
	Receiver(unsigned int pin, void(*messageCallback)(char*), unsigned int bufferSize){
		_messageCallback = messageCallback;
		_bufferSize = bufferSize;
	}

	void setup(){
		if (!_driver.init())
			Serial.println("Receiver setup failed");
	}

	void loop()	{
		uint8_t message[_bufferSize];
		uint8_t buflen = sizeof(message);

		if (_driver.recv(message, &buflen)){
			_messageCallback((char *)message);
		}
	}
};