#include <Arduino.h>
#include <RH_ASK.h>

class Transmitter{
	RH_ASK _driver;

public:

	void setup(){
		if (!_driver.init())
			Serial.println("Transmitter setup failed");
	}

	void send(char* message){
		_driver.send((uint8_t *)message, strlen(message));
		_driver.waitPacketSent();
	}
};